package org.kantega.jexmec.test;

/*
 * Copyright 2011 Kantega AS
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

import org.kantega.jexmec.ServiceKey;
import org.kantega.jexmec.ServiceLocator;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 *
 */
public class TestServiceLocator implements ServiceLocator {
    private final Map<ServiceKey, Object> services = new HashMap<ServiceKey, Object>();

    public Set<ServiceKey> getServiceKeys() {
        return services.keySet();
    }

    public <T> T lookupService(ServiceKey<T> serviceKey) {
        return serviceKey.getServiceType().cast(services.get(serviceKey));
    }

    public <T> void addService(ServiceKey<T> by, T service) {
        services.put(by, service);
    }
}
